<template>
  <div
    v-if="isCompleted && isWin && !isChosenByCarrier && !isCancelled && isSpotListCompleted"
    class="spot-controls__state __lose"
  >
    В аукционе у вас хорошая ставка, но на заказ<br />
    назначен другой перевозчик.
  </div>
  <div
    v-else-if="isCompleted && isLosing && !isChosenByCarrier && !isCancelled && isSpotListCompleted"
    class="spot-controls__state __lose">
    Аукцион выиграл другой перевозчик.<br />
    Ваша ставка слишком высокая.
  </div>
  <div
    v-else-if="isCancelled"
    :class="[
      'spot-controls__state',
      hasParticipantBids ? '__lose' : ''
    ]"
  >
    Заказчик отменил заказ.<br />
    Аукцион был завершен.
  </div>
  <div
    v-else-if="isCompleted && isWin && isChosenByCarrier && isSpotListCompleted"
    class="spot-controls__state __win"
  >
    Поздравляем!<br />
    Вы победили в аукционе.
  </div>
  <div
    v-else-if="isCompleted && isLosing && isChosenByCarrier && isSpotListCompleted"
    class="spot-controls__state __win"
  >
    Поздравляем!<br />
    Вас выбрал заказчик.
  </div>
  <div
    v-else-if="isCompleted && !hasParticipantBids && isSpotListCompleted"
    class="spot-controls__state"
  >
    Время аукциона истекло.<br />
    Заказ ушел другому перевозчику.
  </div>
  <div
    v-else-if="isCompleted && isWin && isSpotListActual && isDownGrade"
    class="spot-controls__state __win"
  >
    Ваша ставка выиграла,<br />
    Ожидаем решения заказчика
  </div>
  <div
    v-else-if="isCompleted && isLosing && isSpotListActual && isDownGrade"
    class="spot-controls__state"
  >
    Ваша ставка не выиграла.<br />
    Ожидаем решения заказчика
  </div>
  <div v-else-if="isBlind" class="spot-controls">
    <div v-if="!spotAuctionByCarrier.auctionInfo.currentPrice">
      <h2 class="spot-controls__subtitle">
        Напишите вашу ставку
      </h2>
      <template>
        <div class="spot-controls__block">
          <ObInput
              v-model="currentPrice"
              :placeholder="!isFocused ? '?' : ''"
              type="money"
              subTitle="₽"
              @focus="isFocused=true"
              @blur="isFocused=false"
              :disabled="isCompleted"
              data-qa="spot-controls_input-blind"
          />
        </div>
        <p class="spot-controls__vat">{{ vatOfBlindAuction }}</p>
        <ObButton
            data-qa="spot-controls_makeBidButton-downgrade"
            :class="[
            'spot-controls__step-button ml50',
            {
              'disabled': isCompleted || !currentPrice
            },
          ]"
            @click="makeBidWrapper"
            label="Сделать ставку"
        />
      </template>
    </div>
    <div v-else-if="spotAuctionByCarrier.auctionInfo.currentPrice">
      <p class="spot-controls__text">
        Ваша ставка принята.<br />
        Ожидаем решения заказчика
      </p>
    </div>
  </div>
  <div v-else class="spot-controls">
    <div>
      <template>
        <div v-if="isDownGrade" class="spot-controls__block">
          <ObButton
            label="—"
            type="outline"
            data-qa="spot-controls_minusButton"
            :class="[
              'spot-controls__block--item',
              { disabled: isCompleted || !isCurrentPricePositive },
            ]"
            @click="onMinus"
          />
          <div
            class="spot-controls__block--item__value"
            data-qa="spot-controls_currentPrice"
          >
            {{ currentPriceWithVat }}
          </div>
          <ObButton
            label="+"
            type="outline"
            data-qa="spot-controls_plusButton"
            :class="[
              'spot-controls__block--item',
              { disabled: isCompleted || currentPriceWithVatMoreBid },
            ]"
            @click="onPlus"
          />
        </div>
        <ObButton
          v-if="isDownGrade || (isFirstApprove && isInProccess && !hasParticipantBids)"
          data-qa="spot-controls_makeBidButton-blind"
          :class="[
            'spot-controls__step-button',
            {
              'disabled': isDisabled,
              'first-approve': isFirstApprove
            }
          ]"
          @click="makeBidWrapper"
          :label="nameButton"
        />
        <div v-else-if="hasAnswer" class="spot-controls__firstapprove-text">
          Ожидаем ответа от заказчика<br />
          до {{transformTime(spotAuctionByCarrier.auctionDt)}}
        </div>
        <div v-else-if="!hasAnswer" class="spot-controls__firstapprove-text __red">
          Заказ взят другим перевозчиком, ждём подтверждения от заказчика
        </div>
      </template>
    </div>
  </div>
</template>

<script>
import api from '@/api'
import ObInput from 'common-components/src/obComponents/obInput'
import ObButton from 'common-components/src/obComponents/obButton'
import { mapActions, mapGetters } from 'vuex'
import { uuid } from 'vue-uuid'
import { formatNumber } from 'common-components/src/helpers/common'
import moment from 'moment'

export default {
  components: {
    ObButton,
    ObInput
  },
  props: {
    spotType: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      initCurrentPrice: 0,
      initVatAmount: 0,
      initBiddingStep: 0,
      currentPrice: null,
      isFocused: false
    }
  },
  mounted() {
    this.spotAuctionByCarrier.auctionInfo.currentPrice
      ? (this.initCurrentPrice = this.spotAuctionByCarrier.auctionInfo.currentPrice)
      : 0
    this.spotAuctionByCarrier.auctionInfo.vatAmount
      ? (this.initVatAmount = this.spotAuctionByCarrier.auctionInfo.vatAmount)
      : 0
    this.spotAuctionByCarrier.auctionInfo.biddingStep
      ? (this.initBiddingStep =
          this.spotAuctionByCarrier.auctionInfo.biddingStep * 100)
      : 0
    if(this.isDownGrade) {
      this.currentPrice = this.initCurrentPrice + this.initVatAmount
    }
  },
  computed: {
    ...mapGetters({
      participantUuid: 'user/participantUuid',
      spotOrderByCarrier: 'spot/spotOrderByCarrier',
      spotAuctionByCarrier: 'spot/spotAuctionByCarrier',
      spotBidsInfoByCarrier: 'spot/spotBidsInfoByCarrier',
      carrierFilter: 'spot/carrierFilter',
      userInfo: 'spot/userInfo'
    }),
    currentPriceWithVat() {
      return this.currentPrice
        ? formatNumber(this.currentPrice / 100) + ' ₽'
        : '–'
    },
    isDisabled() {
      return this.isCompleted || this.currentPriceWithVatMoreBid
    },
    nameButton() {
      return this.isFirstApprove ? 'Взять заказ' :
        this.isDownGrade && !this.hasParticipantBids ? 'Сделать ставку' : 'Обновить ставку'
    },
    isDownGrade() {
      return this.spotType === 'DOWNGRADE'
    },
    isBlind() {
      return this.spotType === 'BLIND'
    },
    isFirstApprove() {
      return this.spotType === 'FIRST_APPROVE'
    },
    isInProccess() {
      return this.spotAuctionByCarrier.auctionStatus === 'IN_PROCCESS'
    },
    isAuctionEnded() {
      return this.spotAuctionByCarrier.auctionStatus === 'AUCTION_ENDED'
    },
    isWin() {
      return this.spotAuctionByCarrier.auctionInfo.currentState === 'WIN'
    },
    isLosing() {
      return this.spotAuctionByCarrier.auctionInfo.currentState === 'LOSING'
    },
    hasBids() {
      return Boolean(this.spotBidsInfoByCarrier.bids)
    },
    hasAnswer() {
      if (this.isInProccess && this.isFirstApprove) {
        return true
      } else {
        return this.hasParticipantBids ? true : this.isAuctionEnded && this.hasBids
      }
    },
    hasParticipantBids() {
      return this.hasBids
        ? this.spotBidsInfoByCarrier.bids.reduce((acc, bid) => {
            if (bid.participantUuid === this.participantUuid) {
              acc += 1
            }
            return Boolean(acc)
          }, false)
        : false
    },
    isCompleted() {
      return this.spotAuctionByCarrier.auctionInfo.lotStatus === 'COMPLETED'
    },
    isCancelled() {
      return this.spotAuctionByCarrier.auctionStatus === 'CANCELLED'
    },
    isChosenByCarrier() {
      return this.spotOrderByCarrier.spotOrder.isCarrierChosen
    },
    isCurrentPricePositive() {
      return (
        (this.spotAuctionByCarrier.auctionInfo.currentPrice + this.spotAuctionByCarrier.auctionInfo.vatAmount) -
        (this.spotAuctionByCarrier.auctionInfo.biddingStep + this.spotAuctionByCarrier.auctionInfo.biddingStepVatAmount) > 0
      )
    },
    currentPriceWithVatMoreBid() {
      return this.spotAuctionByCarrier.auctionInfo.currentPrice + this.spotAuctionByCarrier.auctionInfo.vatAmount <= this.currentPrice
    },
    isSpotListActual() {
      return this.$route.path === '/spot-list'
    },
    isSpotListCompleted() {
      return this.$route.path === '/spot-list-completed'
    },
    vatOfBlindAuction() {
      return this.currentPrice && this.hasVat ? `В том числе НДС ${formatNumber(this.currentPrice / 100 * 0.2)} ₽`
          : !this.currentPrice && this.hasVat ? 'В том числе НДС —'
              : !this.hasVat ? 'НДС не облагается' : '—'
    },
    hasVat() {
      return this.userInfo.contractorInfo.vat
    }
  },
  methods: {
    ...mapActions({
      getSpotOrder: 'spot/getSpotOrderByCarrier',
      getSpotAuction: 'spot/getSpotAuctionByCarrier',
      getSpotTableItems: 'spot/getSpotTableItemsByCarrier',
      getSpotBidsInfo: 'spot/getSpotBidsInfoByCarrier',
    }),
    makeBidWrapper() {
      const body = {
        lotUuid: this.spotOrderByCarrier.auctionUuid,
        bid: this.isFirstApprove ? this.spotAuctionByCarrier.auctionInfo.currentPrice
          : this.spotAuctionByCarrier.auctionInfo.biddingStepVatAmount ? this.currentPrice - (this.currentPrice / 1.2 * 0.2)
          : this.currentPrice
      };
      this.makeBidByCarrier(uuid.v4(), body)
    },
    onMinus() {
      this.currentPrice -= this.spotAuctionByCarrier.auctionInfo.biddingStep + this.spotAuctionByCarrier.auctionInfo.biddingStepVatAmount
    },
    onPlus() {
      this.currentPrice += this.spotAuctionByCarrier.auctionInfo.biddingStep + this.spotAuctionByCarrier.auctionInfo.biddingStepVatAmount
    },
    async makeBidByCarrier(bid_uuid, data) {
      try {
        await api.spotAuction.makeBidByCarrier(bid_uuid, data)
        await this.getSpotOrder(this.spotOrderByCarrier)
        await this.getSpotAuction(this.spotOrderByCarrier.auctionUuid)
        await this.getSpotTableItems(this.carrierFilter)
        await this.getSpotBidsInfo({
          auctionUuid: this.spotOrderByCarrier.auctionUuid,
          orderUuid: this.spotOrderByCarrier.spotOrder.orderUuid,
        })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `${e.details}`,
        })
      }
    },
    transformTime(time) {
      return moment(time).format('HH:mm DD.MM.YYYY')
    },
  }
}
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';

.spot-controls {
  display: flex;
  justify-content: center;
  width: 100%;

  &__state {
    margin: 20px 0;
    line-height: 18px;
    text-align: center;
    letter-spacing: 0.2px;

    &.__win {
      color: $green-800;
    }

    &.__lose {
      color: $color-error;
    }
  }

  &__block {
    display: flex;
    justify-content: space-between;
    margin: 20px 0;

    &--item {
      display: flex;
      flex-direction: column;
      justify-content: center;
      font-size: 16px;
      width: 39px;
      min-width: 54px;
      border-radius: 10px;
      border: 2px solid $color-blue-navy-blue;
      cursor: pointer;

      &.disabled {
        pointer-events: none;
        color: $gray-window;
        border-color: $gray-window;
      }

      &__value {
        font-size: 24px;
        line-height: 20px;
        letter-spacing: 0.2px;
        color: $color-text-base;
        margin: 10px;
      }
    }
  }

  &__content {
    display: flex;
    flex-direction: column;
    align-items: center;
    width: 100%;
    padding: 20px 10px 0 10px;
    &--bid {
      position: relative;
      display: flex;
      justify-content: center;
      align-items: center;
      font-weight: bold;
      font-size: 24px;
      line-height: 36px;
      letter-spacing: 0.2px;
      color: $color-text-base;
      mix-blend-mode: normal;
      opacity: 0.9;
      &span {
        margin-left: 10px;
      }
    }
    &--tax {
      font-size: 10px;
      line-height: 12px;
      letter-spacing: 0.4px;
      color: $gray-slate;
    }
    &__state {
      padding: 10px 0;
      letter-spacing: 0.2px;
      font-size: 14px;
    }
  }

  &__vat {
    font-size: 12px;
    letter-spacing: 0.2px;
    color: $gray-slate;
    text-align: center;
    margin: -10px 0 10px;
  }

  &__step-button {
    margin-left: 30px;
    border-radius: 10px;
    &.disabled {
      pointer-events: none;
    }
    &.first-approve {
      margin-left: 0;
      margin-top: 20px;
    }
  }

  &__firstapprove-text {
    font-size: 14px;
    line-height: 18px;
    text-align: center;
    margin-top: 10px;
    &.__red {
      color: $color-error;
    }
  }

  &__subtitle {
    padding-top: 15px;
    font-size: 20px;
    text-align: center;
  }

  &__text {
    padding-top: 10px;
    font-size: 14px;
    text-align: center;
    color: $green-800;
  }

  .question {
    position: absolute;
    font-size: 12px;
    color: $gray-slate;
    right: -20px;
  }

  .ml50 {
    margin-left: 50px;
  }
}

::v-deep {
  .input-group .input {
    text-align: center;
    font-size: 20px !important;
  }

  .units {
    line-height: 34px;
    &.active {
      font-size: 20px;
    }
  }

  .ob-button-container.primary-type,
  .ob-button-container.primary-type:hover{
    background: $color-blue-navy-blue;
    color: $style-white;
  }
}
</style>
